;PLANE JUMP I editor v0.1
#include "ti82.h"
#include "keys.inc"

RELOCADDR = APD_BUF+300
NewVarName = TEXT_MEM2
LEVELPT = TEXT_MEM
LEVELY = TEXT_MEM+2
MASK    = TEXT_MEM+3
temp = TEXT_MEM+100


.org START_ADDR
StartAddr =$-3

Title2:
.db "PJ I level editor",0

Start:
       ld a,5
       ld (NewVarName),a
        ld hl,RelocRoutines
        ld de,RELOCADDR
        ld bc,RelocRoutinesSize
        ldir

   ;Convert what ASH gives us to what CrASH would have done..
        ld hl,(8D5Dh)
        ld de,302Eh  ; .0 from ash 3.0
        or a
        sbc hl,de
        jr nz,NotASHfix
        pop de
        pop bc
        pop hl
        dec hl
        dec hl
        dec hl
        push de
        push hl
        add hl,bc
        ld bc,3
        ld de,StartAddr+ProgSize
        call SwapBytes
        ld c,3
        pop hl
        ld de,StartAddr
        call SwapBytes
        pop hl
        inc c
        push de
        push bc
        push hl
        jr ASHFixed
NotASHfix:
	ld hl,VarName
	rst 20h
	call _CHKFINDSYM
	ex de,hl
	inc hl
	inc hl
        push hl         ;save current prog addr
ASHFixed:
        call DeleteTemp

;-------------------------------------------------------------------------------
;Built-in Level editor:
;-------------------------------------------------------------------------------
 call ClearAPD
 call _GRBUFCLR   ;Clear GRAPH_MEM

DispLevelEdit:
 ROM_CALL(CLEARLCD)  ;Clear LCD
 set 7, (iy+$14)   ;Write Text to GRAPH_MEM
 ld     HL, Title
 ld     B, 6
 ld     DE, $011A
 ld     (CURSOR_X), DE
 ROM_CALL(D_ZM_STR)
 inc    D

Disp:
 ld     A, D
 add    A, 6
 ld     D, A
 ld     E, $1A
 ld     (CURSOR_X), DE
 ROM_CALL(D_ZM_STR)
 djnz   Disp
 res 7, (iy+$14)  ;Stop writing to graph_mem
 xor    A
 ld     (LEVELY), a
 call   EDrwScreen
 ld     A, $80
 ld     (MASK), a
 ld     B, 0
 ld     C, 60
KeyLoop:
WaitKey:
 call   DrawBox  ;Flash box
 push bc
 ROM_CALL(DISP_GRAPH) ;neccessary for smooth scrolling
 pop bc
 call   DrawBox
 push bc
 ROM_CALL(DISP_GRAPH) ;neccessary for smooth scrolling
 pop bc
 call   GET_KEY  ;Test for keys
 and    A
 jr     z, WaitKey
 cp     G_DOWN
 jr     z, MoveDown
 cp     G_LEFT
 jr     z, MoveLeft
 cp     G_RIGTH
 jp     z, MoveRight
 cp     G_UP
 jp     z, MoveUp
 cp     G_2nd
 jp     z, ChangeStone
 cp     G_MODE
 jp     z, ClearLevel
 cp     G_CLEAR
 jp z,Exit
 cp     G_DEL
 jp     z,ExitEditor
 cp     G_YEDIT
 jr     nz, KeyLoop
LoadLevel:
 call Write   ;Right the name
  ld hl,NewVarName   ; the name of the prog
  rst 20h
 
 call _CHKFINDSYM   ;Find the prog
 jp c,Exit

 ex de,hl
 call LoadDataFromVar
 ld a,h
 or a
 jp nz,Exit
 ld a,l
 cp 3
 jp nz,Exit

 ld     HL, APD_BUF
 ld     (LEVELPT), HL
 jp     DispLevelEdit 



MoveDown:
 ld     A, (LEVELY)
 and    A
 jp     z, KeyLoop
 dec    A
 ld     (LEVELY), a
 inc    C
 inc    C
 ld   a, c
 cp   62
 jp   nz, KeyLoop
 ld   hl, (LEVELPT)
 dec  hl
 ld   (LEVELPT), hl
 ld   c, 60
 call   EDrwScreen
 jp KeyLoop
MoveLeft:
 ld   a, b
 and  a
 jp   z, KeyLoop
 dec  b
 dec  b
 ld   a, (MASK)
 add  a, a
 ld   (MASK), a
 jp   KeyLoop
MoveRight:
 ld   a, b
 cp   14
 jp   z, KeyLoop
 inc  b
 inc  b
 ld   a, (MASK)
 rrca
 ld   (MASK), a
 jp   KeyLoop
MoveUp:
 ld   a, (LEVELY)
 cp   252
 jp     z, KeyLoop
 inc  a
 ld   (LEVELY), a
 dec  c
 dec  c
 ld   a, c
 and  a
 jp     nz, KeyLoop
 ld   hl, (LEVELPT)
 inc  hl
 ld   (LEVELPT), hl
 ld   c, 2
 call   EDrwScreen
 jp     KeyLoop
ChangeStone:
 ld     HL, (LEVELPT)
 ld     A, 60
 sub    C
 ld     E, A
 srl    E
 ld     D, 0
 add    HL, DE
 ld     A, (MASK)
 xor    (HL)
 ld     (HL), A
 call   EDrwScreen
 jp     KeyLoop

ClearLevel:
 call ClearAPD

 call   _GRBUFCLR
 jp     DispLevelEdit

ExitEditor:
 call Write
 ld hl,258
 call CreateWorldVar
 jr c,Exit

SaveStuff:      ;Save Stuff to VAR
 ex de,hl
 inc hl
 inc hl                ; skip the size
 ld     (hl), 3
 inc    hl
 ld     (hl), 0
 inc    hl     ; Plain Jump level header
 ex     de,hl
 ld     HL, APD_BUF
 ld     BC, 256
 ldir          ; copy the level data

Exit:
        call RecreateTemp
        ld hl,(8D5Dh)
        ld de,302Eh  ; .0 from ash 3.0
        or a
        sbc hl,de
        jp z,DeRelocate
        jp Terminate

;-----------------------------------------------------------------------------
;EDrwScreen: draws screen
;-----------------------------------------------------------------------------
EDrwScreen:
 push   BC
 call ClearGraph

 ld     HL, (LEVELPT)
 ld     B, 30
DrawLoop:
 ld     A, B
 add    A, A
 ld     C, A
 push   BC
 ld     D, $80
 ld     B, 0
DrawLoop_:
 ld     A, (HL)
 and    D
 call   nz, DrawBox
 inc    B
 inc    B
 rrc    D
 jr     nc, DrawLoop_
 pop    BC
 inc    HL
 djnz   DrawLoop
 ROM_CALL(DISP_GRAPH)
 pop bc
 ret
;-----------------------------------------------------------------------------
;DrawBox
;-----------------------------------------------------------------------------
DrawBox:
 push bc
 push hl
 push de
 call FINDPIXEL
 ld   de,GRAPH_MEM
 add  hl,de
 ld   c, a
 xor  (hl)
 ld   (hl),a
 ld   a, c
 rrca
 xor  (hl)
 ld   (hl), a
 ld   de, 12
 add  hl, de
 ld   a, c
 xor  (hl)
 ld   (hl), a
 ld   a, c
 rrca
 xor  (hl)
 ld   (hl), a
 pop  de
 pop  hl
 pop  bc
 ret

Title:          .db "PJ I level editor",0
Arrow:          .db "ARROWS to Move",0
SecondT:        .db "2ND to Change Block",0
ExitT:          .db "MODE to Clear Level",0
DelT:           .db "DEL to Save Level",0
Clear:          .db "CLEAR to Exit",0
Load:           .db "Y= to Load a Level",0

EnterN:         .db "ENTER NAME:",0

;-------------------------------------------------------------------------------
;FINDPIXEL Routine, by Patrick Davidson [From Zkart3d 82]
;-------------------------------------------------------------------------------
FINDPIXEL_DATA:
         .db      128,64,32,16,8,4,2,1
FINDPIXEL:
         push     bc
         ld       a,b
         and      7
         ld       hl,FINDPIXEL_DATA
         ld       e,a
         ld       d,0
         add      hl,de
         ld       e,(hl)            ; E = pixel mask

        ld a,c

         add      a,a
         add      a,c               ; A = 3 * Y
         ld       l,a
         ld       h,0
         add      hl,hl
         add      hl,hl             ; HL = 12 * Y
         ld       a,b
         ld       b,0
         rrca
         rrca
         rrca
         and      15
         ld       c,a
         add      hl,bc
         ld       a,e               ; A = pixel mask
         pop      bc
         ret

_GRBUFCLR:
 ld hl,GRAPH_MEM
 ld bc,767
 jr OTH_CLEAR

ClearAPD:
 ld     HL, APD_BUF
 ld     (LEVELPT), HL
 ld     BC, 299

OTH_CLEAR:
 ld (hl),0
 ld d,h
 ld e,l
 inc de
 ldir
 ret


ClearGraph:   ;Clear only the first 24 pixels in each row
 push bc
 ld b, 64
 ld hl, GRAPH_MEM
 ld de, 12
 call Loop
 ld b, 64
 ld hl, GRAPH_MEM+1
 ld de, 12
 call Loop
 pop bc 
 ret
Loop:
 ld (hl), 0
 add hl, de
 djnz Loop
 ret


Write:
 ld hl,NewVarName+1
 ld bc,8
 call OTH_CLEAR
         ROM_CALL(CLEARLCD)
 	   ld de,$0000
	   ld (CURSOR_ROW),de
	   ld hl,EnterN
 	   ROM_CALL(D_ZT_STR)
         ld       hl,$0403
         ld       (CURSOR_ROW),hl
         ld       hl, NewVarName+1
         push     hl
         ld       b,8
space_loop:
         ld       (hl), ' '
         inc      hl
         djnz     space_loop
         pop      ix

enter_name_loop:
	 call     GET_KEY
         or       A
         jr       z,enter_name_loop
         cp       $38
         jr       z,backup
         SUB      9
         ret      z
         dec      a
         jp       m,enter_name_loop
         ld       hl,chartable
         ld       e,a
         ld       d,0
         add      hl,de
         ld       a,8
         cp       b
         jr       z,enter_name_loop
         ld       a,(hl)
         or       a
         jr       z,enter_name_loop
         ld       (ix),a
	   ROM_CALL(TX_CHARPUT)
         inc      b
         inc      ix
         jr       enter_name_loop
backup:  xor      a
         cp       b
         jr       z,enter_name_loop
         dec      b
         dec      ix
         ld       a,' '

         ld       (ix),a
         ld       hl,CURSOR_COL
         dec      (hl)
	   ROM_CALL(TX_CHARPUT)
         dec      (hl)
         jr       enter_name_loop

chartable:
         .db      ":WRMH."
         .DB      "..0VQLG!..ZUPKFC"
         .DB      "..YTOJEBX.>SNIDA"
         .DB      ".12345.."

RelocRoutines:
adj = RELOCADDR-RelocRoutines

LoadDataFromVar = $+adj
 call DeRelocate
 inc hl
 inc hl
 ld c,(hl)
 inc hl
 ld b,(hl)
 inc hl
 push bc
 ld     DE, APD_BUF
 ld     BC, 256
 ldir
 pop hl
 jr Relocate

SaveStuff2 = $+adj      ;Save Stuff to VAR
 ex de,hl
 push hl
 call DeRelocate
 pop hl
 inc hl
 inc hl                ; skip the size
 ld     (hl), 3
 inc    hl
 ld     (hl), 0
 inc    hl     ; Plain Jump level header
 ex     de,hl
 ld     HL, APD_BUF
 ld     BC, 256
 ldir          ; copy the level data
 call Relocate+adj
 inc sp
 inc sp
 jp Exit




DeleteTemp =$+adj
        call DeRelocate
        ROM_CALL(3620h-1Ah)
        jr Relocate
RecreateTemp =$+adj
        call DeRelocate
        ROM_CALL(38EAh-1Ah)
Relocate:
        xor a
        jr DoDeRelocate
DeRelocate =$+adj
        ld a,1
DoDeRelocate:
        push hl
        push af
	ld hl,VarName
	rst 20h
        ROM_CALL(213Eh-1Ah)     ;_CHKFINDSYM
        inc de
        inc de
        ex de,hl
        pop bc
DoTerminate:
        ld de,StartAddr
        sbc hl,de
        rla
        add hl,de
        xor b
        ld bc,ProgSize
        rra
        jr nc,DoReloc
        add hl,bc
        ld de,StartAddr+ProgSize-1
ReverseSwapBytes:
        dec hl
	ld a,(de)
        ldd
        inc hl
	ld (hl),a
	ld a,b
	or c
        jr nz,ReverseSwapBytes
        pop hl
	ret
SwapBytes =$+adj
        push hl
DoReloc:
	ld a,(de)
	ldi
	dec hl
	ld (hl),a
	inc hl
	ld a,b
	or c
	jr nz,DoReloc
        pop hl
	ret

Terminate =$+adj
        call DeRelocate
        pop hl
        push hl
        jr DoTerminate

CreateVar =$+adj
        push hl
        push de
        call DeRelocate
        pop hl
        rst 20h
        pop hl
        ROM_CALL(23B1h-1Ah)             ;_CREATEPRGM
        ld (hl),6       ;lock prgm
        push de
        call Relocate+adj
        pop de
        ret

VarName =$+adj
 .db 6,"PJ1EDIT",0

RelocRoutinesSize = $-RelocRoutines



CreateWorldVar:         ;HL = size of var to create, NewVarName contains name
                        ; NewVarName must not be in program code.. should be
                        ; in APD_BUF or graphmem or similar
        push hl
        ld hl,NewVarName
        rst 20h
        call _CHKFINDSYM
        ccf
        pop hl
        jp c,SaveStuff2                   ;return if var already exists
        push hl
        ld a,(NewVarName)
        ROM_CALL(22C8h-1Ah)     ;check if there's enough ram
        pop hl
        ret c                   ;return if not
        ld de,NewVarName
        call CreateVar          ;create the variable
        or a
        ret     ;now DE = addr of variable and HL = addr of VAT entry


_CHKFINDSYM:    ROM_CALL(213Eh-1Ah)             \ ret

ProgSize        =$-StartAddr


.end

